unit mydockedwindow;
interface

uses Classes, SysUtils, Forms, LCLType, Controls, Graphics, Dialogs,
  IDECommands, MenuIntf, ExtCtrls;
     //Dialogs;



procedure Register;

resourcestring
  mnuShowDockedWindow = 'Show MyDockedWindow';


type
  { TMyDockedWindow }

  TMyDockedWindow = class(TCustomControl)
  private
    FForm : TCustomform;
    FPanel: TPanel;
    procedure FPanelEndDock(Sender, Target: TObject; X, Y: Integer);
    procedure OnCmdClick(Sender: TObject);
  protected

  public

   constructor Create(AOwner: TComponent); override;
   destructor Destroy; override;
  end;

var
  Cmd: TIDEMenuCommand = nil;
  ADockedWindow: TMyDockedWindow = nil;
  CmdMessageComposer: TIDECommand;

implementation

procedure TMyDockedWindow.OnCmdClick(Sender: TObject);
begin
 if assigned(FForm) then FreeAndNil(FForm);

 FForm         := TForm.Create(self);
 FForm.Caption := 'My Docked Window';
 FForm.SetBounds(100,100,500,800);

 FPanel            := TPanel.Create(nil);
 FPanel.Parent     := FForm;
 FPanel.Align      := alClient;
 FPanel.Constraints.MinWidth:= 100;
 FPanel.Color      := clYellow;
 FPanel.DragKind   := dkDock;
 FPanel.DragMode   := dmAutomatic;
 FPanel.OnEndDock  :=@FPanelEndDock;

 FForm.Show;
end;

procedure TMyDockedWindow.FPanelEndDock(Sender, Target: TObject; X, Y: Integer);
begin
 if assigned(FForm) then FreeAndNil(FForm);
end;

constructor TMyDockedWindow.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);

end;

destructor TMyDockedWindow.Destroy;
begin
 if assigned(FPanel) then FreeAndNil(FPanel);
 if assigned(FForm) then FreeAndNil(FForm);
 inherited Destroy;
end;


procedure Register;
var Key: TIDEShortCut;
    Cat: TIDECommandCategory;
    CmdMyTool: TIDECommand;
begin
  ADockedWindow := TMyDockedWindow.Create(nil);
// register IDE shortcut and menu item
  Key := IDEShortCut(VK_M,[ssCtrl],VK_UNKNOWN,[]);
  Cat:=IDECommandList.FindIDECommand(ecFind).Category;
  CmdMyTool := RegisterIDECommand(Cat,mnuShowDockedWindow, mnuShowDockedWindow, Key, @ADockedWindow.OnCmdClick, nil);

//Erzeugt den Menüeintrag:
  Cmd := RegisterIDEMenuCommand(itmCustomTools, 'Show MyDockedWindow', mnuShowDockedWindow,  nil, nil, CmdMyTool);


end;

initialization

finalization
  ADockedWindow.Free;

end.
